"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Document client for using in testing
 */
class default_1 {
    batchesSize = 2;
    list = [];
    scan(i) {
        return {
            promise: () => new Promise((rs) => rs(this.getNexResponse(i))),
        };
    }
    query(i) {
        return {
            promise: () => new Promise((rs) => rs(this.getNexResponse(i)))
        };
    }
    getNexResponse(i) {
        const firstIndex = i.ExclusiveStartKey ? this.findIndexOfKey(i.ExclusiveStartKey) + 1 : 0;
        const lastIndex = firstIndex + this.batchesSize;
        const batch = this.list.slice(firstIndex, lastIndex).filter((i) => i.matches !== false).map((i) => i.value);
        const lastEvaluatedKey = lastIndex >= this.list.length ? undefined : this.list[lastIndex - 1].value;
        return {
            Items: batch,
            LastEvaluatedKey: lastEvaluatedKey,
        };
    }
    findIndexOfKey(key) {
        return this.list.findIndex((i) => this.keyMatches(i.value, key));
    }
    keyMatches(item, key) {
        return Array.from(Object.keys(key)).reduce((prev, current) => prev && (item[current] === key[current]), true);
    }
}
exports.default = default_1;
//# sourceMappingURL=fake.document-client.class.js.map